/* Interactive LED Ball - TechKiwiGadgets Jan 2018
 *  Simplified menus
 */

/* ============================================
I2Cdev device library code is placed under the MIT license
Copyright (c) 2012 Jeff Rowberg

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
===============================================
*/

//**********************************************************
 // MPU-6050 Short Example Sketch
// By Arduino User JohnChi
// August 17, 2014
// Public Domain
#include<Wire.h>


const int MPU_addr=0x68;  // I2C address of the MPU-6050
int16_t AcX,AcY,AcZ,Tmp,GyX,GyY,GyZ;

// WS2182 LED Driver Library Setup *************************************************************************
#include "FastLED.h"
// How many leds in your strip?
#define NUM_LEDS 130 // Note: First LED is address 0
#define DATA_PIN 3 // Note: D3 used to control LED chain
int t1 = 500; // Delay in Milliseconds for startup routine

int LEDP1; //Variable used for Led Pattern 1
float LEDcalc; // Temp variable used to calculate test coordinates

// Define the array of leds
CRGB leds[NUM_LEDS];

// Smoothing Variables for LPF
const float alpha = 0.98; 
float smoothedX = 10;
float smoothedY = 10;
float smoothedZ = 10;
int gX = 57; // Pointer for Menu 5 option first LED on Xaxis in centre
int gY = 0; // Pointer for Menu 5 option

// Menu Selection
int menu = 1; // Random Dot Pattern

int direct; // Temp direction variable

int d1 = 50; // Delay between Dots beingmoved in screen 1
int d2 = 1000;
int d5 = 70;

int startdelay = 500; // Number cycles to settle the MPU readings 

int g = 0; // Scracth variable
int i = 0; // Scracth variable
boolean cal = false; // Callibrate delay

int xb;
int yb;
int zb;

int Xdiff = 0; // Used to track the difference between baselib=ne Gyro and current readings
int Ydiff = 0;
int Zdiff = 0;

int dt = 66; // Coordinate of current dotontop

int r = 27; // Start point for Dot on top

int osX = 18000; // This is Gyro Offset
int osY = 18000; // This is Gyro Offset
int osZ = 18000; // This is Gyro Offset range of -17700 to 15200 therefore normalised to 32900 range by adding 17700

int xgap = 3200; // Difference between LEDs in Xaxis
int ygap = 2200; // Difference 

float josX = 0.014; // Used to convert Gyro outputs to number below 255 
float josY = 0.014; // Used to convert Gyro outputs to number below 255 
float josZ = 0.014; // Used to convert Gyro outputs to number below 255 

int Xcol = 0; // Final Gyro Color value
int Ycol = 0; // Final Gyro Color value
int Zcol = 0; // Final Gyro Color value

/* Dot Arrays track location of a item
    Dot number identifier for each Dot
    0. LED Position  = 0-129
    1. Current Direction  = 0-7
    2. Prev Position = 0-129
    3. Prev Prev Position= 1-129
0 = Up
1 = Up Right  
2 = Right 
3 =  Down Right 
4 = Down
5 = Down Left
6 = Left
7 = Up Left
*/
int dot[4][5] = { // Setup Location for 4 Dot Snakes 4 dots long
      {5 , 5, 18, 34, 50},
      {1 , 5, 10, 26, 42},
      {126 , 0, 117, 101, 85},
      {122 , 0, 108, 92, 76}
      
};


// Menu Gaxis Array 
int dY[20] = { 0, 1, 10, 26, 42, 58, 74 , 90, 106, 121, 129, 125, 114, 98, 82,66, 50, 34, 18, 5};


/* ************************************************************************
 *  The pixel Array carries the Coordinates of each LED in sequential order
LED Position
0 = Up
1 = Up Right  
2 = Right 
3 =  Down Right 
4 = Down
5 = Down Left
6 = Left
7 = Up Left
8 = LED Row Number
9 = LED Row Position Number
****************************************************************************
*/
  
const int pixel[130][10] PROGMEM = {
      {  5 , 6 , 7 , 8 , 1 , 2 , 3 , 4 , 1 , 1 },
      { 0 , 7 , 8 , 9 , 10  , 11  , 2 , 3 , 2 , 1 },
      { 0 , 8 , 1 , 11  , 12  , 13  , 3 , 4 , 2 , 2 },
      { 0 , 1 , 2 , 13  , 14  , 15  , 4 , 5 , 2 , 3 },
      { 0 , 2 , 3 , 15  , 16  , 17  , 5 , 6 , 2 , 4 },
      { 0 , 3 , 4 , 17  , 18  , 19  , 6 , 7 , 2 , 5 },
      { 0 , 4 , 5 , 19  , 20  , 21  , 7 , 8 , 2 , 6 },
      { 0 , 5 , 6 , 21  , 22  , 23  , 8 , 1 , 2 , 7 },
      { 0 , 6 , 7 , 23  , 24  , 9 , 1 , 2 , 2 , 8 },
      { 1 , 8 , 24  , 40  , 25  , 26  , 10  , 1 , 3 , 1 },
      { 1 , 8 , 9 , 25  , 26  , 27  , 11  , 2 , 3 , 2 },
      { 2 , 1 , 10  , 26  , 27  , 28  , 12  , 2 , 3 , 3 },
      { 2 , 1 , 11  , 27  , 28  , 29  , 13  , 3 , 3 , 4 },
      { 3 , 2 , 12  , 28  , 29  , 30  , 14  , 3 , 3 , 5 },
      { 3 , 2 , 13  , 29  , 30  , 31  , 15  , 4 , 3 , 6 },
      { 4 , 3 , 14  , 30  , 31  , 32  , 16  , 4 , 3 , 7 },
      { 4 , 3 , 15  , 31  , 32  , 33  , 17  , 5 , 3 , 8 },
      { 5 , 4 , 16  , 32  , 33  , 34  , 18  , 5 , 3 , 9 },
      { 5 , 4 , 17  , 33  , 34  , 35  , 19  , 6 , 3 , 10  },
      { 6 , 5 , 18  , 34  , 35  , 36  , 20  , 6 , 3 , 11  },
      { 6 , 5 , 19  , 35  , 36  , 37  , 21  , 7 , 3 , 12  },
      { 7 , 6 , 20  , 36  , 37  , 38  , 22  , 7 , 3 , 13  },
      { 7 , 6 , 21  , 37  , 38  , 39  , 23  , 8 , 3 , 14  },
      { 8 , 7 , 22  , 38  , 39  , 40  , 24  , 8 , 3 , 15  },
      { 8 , 7 , 23  , 39  , 40  , 25  , 25  , 1 , 3 , 16  },
      { 9 , 24  , 40  , 56  , 41  , 42  , 26  , 10  , 4 , 1 },
      { 10  , 9 , 25  , 41  , 42  , 43  , 27  , 11  , 4 , 2 },
      { 11  , 10  , 26  , 42  , 43  , 44  , 28  , 12  , 4 , 3 },
      { 12  , 11  , 27  , 43  , 44  , 45  , 29  , 13  , 4 , 4 },
      { 13  , 12  , 28  , 44  , 45  , 46  , 30  , 14  , 4 , 5 },
      { 14  , 13  , 29  , 45  , 46  , 47  , 31  , 15  , 4 , 6 },
      { 15  , 14  , 30  , 46  , 47  , 48  , 32  , 16  , 4 , 7 },
      { 16  , 15  , 31  , 47  , 48  , 49  , 33  , 17  , 4 , 8 },
      { 17  , 16  , 32  , 48  , 49  , 50  , 34  , 18  , 4 , 9 },
      { 18  , 17  , 33  , 49  , 50  , 51  , 35  , 19  , 4 , 10  },
      { 19  , 18  , 34  , 50  , 51  , 52  , 36  , 20  , 4 , 11  },
      { 20  , 19  , 35  , 51  , 52  , 53  , 37  , 21  , 4 , 12  },
      { 21  , 20  , 36  , 52  , 53  , 54  , 38  , 22  , 4 , 13  },
      { 22  , 21  , 37  , 53  , 54  , 55  , 39  , 23  , 4 , 14  },
      { 23  , 22  , 38  , 54  , 55  , 56  , 40  , 24  , 4 , 15  },
      { 24  , 23  , 39  , 55  , 56  , 41  , 25  , 9 , 4 , 16  },
      { 25  , 40  , 56  , 72  , 57  , 58  , 42  , 26  , 5 , 1 },
      { 26  , 25  , 41  , 57  , 58  , 59  , 43  , 27  , 5 , 2 },
      { 27  , 26  , 42  , 58  , 59  , 60  , 44  , 28  , 5 , 3 },
      { 28  , 27  , 43  , 59  , 60  , 61  , 45  , 29  , 5 , 4 },
      { 29  , 28  , 44  , 60  , 61  , 62  , 46  , 30  , 5 , 5 },
      { 30  , 29  , 45  , 61  , 62  , 63  , 47  , 31  , 5 , 6 },
      { 31  , 30  , 46  , 62  , 63  , 64  , 48  , 32  , 5 , 7 },
      { 32  , 31  , 47  , 63  , 64  , 65  , 49  , 33  , 5 , 8 },
      { 33  , 32  , 48  , 64  , 65  , 66  , 50  , 34  , 5 , 9 },
      { 34  , 33  , 49  , 65  , 66  , 67  , 51  , 35  , 5 , 10  },
      { 35  , 34  , 50  , 66  , 67  , 68  , 52  , 36  , 5 , 11  },
      { 36  , 35  , 51  , 67  , 68  , 69  , 53  , 37  , 5 , 12  },
      { 37  , 36  , 52  , 68  , 69  , 70  , 54  , 38  , 5 , 13  },
      { 38  , 37  , 53  , 69  , 70  , 71  , 55  , 39  , 5 , 14  },
      { 39  , 38  , 54  , 70  , 71  , 72  , 56  , 40  , 5 , 15  },
      { 40  , 39  , 55  , 71  , 72  , 57  , 41  , 25  , 5 , 16  },
      { 41  , 56  , 72  , 88  , 73  , 74  , 58  , 42  , 6 , 1 },
      { 42  , 41  , 57  , 73  , 74  , 75  , 59  , 43  , 6 , 2 },
      { 43  , 42  , 58  , 74  , 75  , 76  , 60  , 44  , 6 , 3 },
      { 44  , 43  , 59  , 75  , 76  , 77  , 61  , 45  , 6 , 4 },
      { 45  , 44  , 60  , 76  , 77  , 78  , 62  , 46  , 6 , 5 },
      { 46  , 45  , 61  , 77  , 78  , 79  , 63  , 47  , 6 , 6 },
      { 47  , 46  , 62  , 78  , 79  , 80  , 64  , 48  , 6 , 7 },
      { 48  , 47  , 63  , 79  , 80  , 81  , 65  , 49  , 6 , 8 },
      { 49  , 48  , 64  , 80  , 81  , 82  , 66  , 50  , 6 , 9 },
      { 50  , 49  , 65  , 81  , 82  , 83  , 67  , 51  , 6 , 10  },
      { 51  , 50  , 66  , 82  , 83  , 84  , 68  , 52  , 6 , 11  },
      { 52  , 51  , 67  , 83  , 84  , 85  , 69  , 53  , 6 , 12  },
      { 53  , 52  , 68  , 84  , 85  , 86  , 70  , 54  , 6 , 13  },
      { 54  , 53  , 69  , 85  , 86  , 87  , 71  , 55  , 6 , 14  },
      { 55  , 54  , 70  , 86  , 87  , 88  , 72  , 56  , 6 , 15  },
      { 56  , 55  , 71  , 87  , 88  , 73  , 57  , 41  , 6 , 16  },
      { 57  , 72  , 88  , 104 , 89  , 90  , 74  , 58  , 7 , 1 },
      { 58  , 57  , 73  , 89  , 90  , 91  , 75  , 59  , 7 , 2 },
      { 59  , 58  , 74  , 90  , 91  , 92  , 76  , 60  , 7 , 3 },
      { 60  , 59  , 75  , 91  , 92  , 93  , 77  , 61  , 7 , 4 },
      { 61  , 60  , 76  , 92  , 93  , 94  , 78  , 62  , 7 , 5 },
      { 62  , 61  , 77  , 93  , 94  , 95  , 79  , 63  , 7 , 6 },
      { 63  , 62  , 78  , 94  , 95  , 96  , 80  , 64  , 7 , 7 },
      { 64  , 63  , 79  , 95  , 96  , 97  , 81  , 65  , 7 , 8 },
      { 65  , 64  , 80  , 96  , 97  , 98  , 82  , 66  , 7 , 9 },
      { 66  , 65  , 81  , 97  , 98  , 99  , 83  , 67  , 7 , 10  },
      { 67  , 66  , 82  , 98  , 99  , 100 , 84  , 68  , 7 , 11  },
      { 68  , 67  , 83  , 99  , 100 , 101 , 85  , 69  , 7 , 12  },
      { 69  , 68  , 84  , 100 , 101 , 102 , 86  , 70  , 7 , 13  },
      { 70  , 69  , 85  , 101 , 102 , 103 , 87  , 71  , 7 , 14  },
      { 71  , 70  , 86  , 102 , 103 , 104 , 88  , 72  , 7 , 15  },
      { 72  , 71  , 87  , 103 , 104 , 89  , 73  , 57  , 7 , 16  },
      { 73  , 88  , 104 , 120 , 105 , 106 , 90  , 74  , 8 , 1 },
      { 74  , 73  , 89  , 105 , 106 , 107 , 91  , 75  , 8 , 2 },
      { 75  , 74  , 90  , 106 , 107 , 108 , 92  , 76  , 8 , 3 },
      { 76  , 75  , 91  , 107 , 108 , 109 , 93  , 77  , 8 , 4 },
      { 77  , 76  , 92  , 108 , 109 , 110 , 94  , 78  , 8 , 5 },
      { 78  , 77  , 93  , 109 , 110 , 111 , 95  , 79  , 8 , 6 },
      { 79  , 78  , 94  , 110 , 111 , 112 , 96  , 80  , 8 , 7 },
      { 80  , 79  , 95  , 111 , 112 , 113 , 97  , 81  , 8 , 8 },
      { 81  , 80  , 96  , 112 , 113 , 114 , 98  , 82  , 8 , 9 },
      { 82  , 81  , 97  , 113 , 114 , 115 , 99  , 83  , 8 , 10  },
      { 83  , 82  , 98  , 114 , 115 , 116 , 100 , 84  , 8 , 11  },
      { 84  , 83  , 99  , 115 , 116 , 117 , 101 , 85  , 8 , 12  },
      { 85  , 84  , 100 , 116 , 117 , 118 , 102 , 86  , 8 , 13  },
      { 86  , 85  , 101 , 117 , 118 , 119 , 103 , 87  , 8 , 14  },
      { 87  , 86  , 102 , 118 , 119 , 120 , 104 , 88  , 8 , 15  },
      { 88  , 87  , 103 , 119 , 120 , 105 , 89  , 73  , 8 , 16  },
      { 89  , 104 , 120 , 128 , 128 , 121 , 106 , 90  , 9 , 1 },
      { 90  , 89  , 105 , 128 , 121 , 122 , 107 , 91  , 9 , 2 },
      { 91  , 90  , 106 , 121 , 121 , 122 , 108 , 92  , 9 , 3 },
      { 92  , 91  , 107 , 121 , 122 , 123 , 109 , 93  , 9 , 4 },
      { 93  , 92  , 108 , 122 , 122 , 123 , 110 , 94  , 9 , 5 },
      { 94  , 93  , 109 , 122 , 123 , 124 , 111 , 95  , 9 , 6 },
      { 95  , 94  , 110 , 123 , 123 , 124 , 112 , 96  , 9 , 7 },
      { 96  , 95  , 111 , 123 , 124 , 125 , 113 , 97  , 9 , 8 },
      { 97  , 96  , 112 , 124 , 124 , 125 , 114 , 98  , 9 , 9 },
      { 98  , 97  , 113 , 124 , 125 , 126 , 115 , 99  , 9 , 10  },
      { 99  , 98  , 114 , 125 , 125 , 126 , 116 , 100 , 9 , 11  },
      { 100 , 99  , 115 , 125 , 126 , 127 , 117 , 101 , 9 , 12  },
      { 101 , 100 , 116 , 126 , 126 , 127 , 118 , 102 , 9 , 13  },
      { 102 , 101 , 117 , 126 , 127 , 128 , 119 , 103 , 9 , 14  },
      { 103 , 102 , 118 , 127 , 127 , 128 , 120 , 104 , 9 , 15  },
      { 104 , 103 , 119 , 127 , 128 , 121 , 105 , 89  , 9 , 16  },
      { 106 , 105 , 128 , 127 , 129 , 123 , 122 , 107 , 10  , 1 },
      { 108 , 107 , 121 , 128 , 129 , 124 , 123 , 109 , 10  , 2 },
      { 110 , 109 , 122 , 121 , 129 , 125 , 124 , 111 , 10  , 3 },
      { 112 , 111 , 123 , 122 , 129 , 126 , 125 , 113 , 10  , 4 },
      { 114 , 113 , 124 , 123 , 129 , 127 , 126 , 115 , 10  , 5 },
      { 116 , 115 , 125 , 124 , 129 , 128 , 127 , 117 , 10  , 6 },
      { 118 , 117 , 126 , 125 , 129 , 121 , 128 , 119 , 10  , 7 },
      { 120 , 119 , 127 , 126 , 129 , 122 , 121 , 105 , 10  , 8 },
      { 121 , 128 , 127 , 126 , 125 , 124 , 123 , 122 , 11  , 1 }
  };

void setup(){
    // WS2182 LED Driver Setup
      LEDS.addLeds<WS2812,DATA_PIN,GRB>(leds,NUM_LEDS); // Default if RGB for this however may vary dependent on LED manufacturer
      LEDS.setBrightness(10); //Set brightness of LEDs here

    // Setup Input Mode and Select Push Buttons
    pinMode(4,INPUT_PULLUP); // Mode Button
    pinMode(5,INPUT_PULLUP); // Mode Button    

    // Setup MIC input modes for each MIC unit
    pinMode(A2,INPUT); // MIC 1 input 
  
  Wire.begin();
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x6B);  // PWR_MGMT_1 register
  Wire.write(0);     // set to zero (wakes up the MPU-6050)
  Wire.endTransmission(true);
  Serial.begin(115200);


  // Randomseed will shuffle the random function
  randomSeed(analogRead(0));

  
}


void loop(){

 buttoncheck();
  
  
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x3B);  // starting with register 0x3B (GYRO_XOUT_H)
  Wire.endTransmission(false);
  Wire.requestFrom(MPU_addr,6,true);  // request a total of 6 registers

 /* 
  AcX=Wire.read()<<8|Wire.read();  // 0x3B (ACCEL_XOUT_H) & 0x3C (ACCEL_XOUT_L)     
  AcY=Wire.read()<<8|Wire.read();  // 0x3D (ACCEL_YOUT_H) & 0x3E (ACCEL_YOUT_L)
  AcZ=Wire.read()<<8|Wire.read();  // 0x3F (ACCEL_ZOUT_H) & 0x40 (ACCEL_ZOUT_L)
  Tmp=Wire.read()<<8|Wire.read();  // 0x41 (TEMP_OUT_H) & 0x42 (TEMP_OUT_L)
  GyX=Wire.read()<<8|Wire.read();  // 0x43 (GYRO_XOUT_H) & 0x44 (GYRO_XOUT_L)
  GyY=Wire.read()<<8|Wire.read();  // 0x45 (GYRO_YOUT_H) & 0x46 (GYRO_YOUT_L)
  GyZ=Wire.read()<<8|Wire.read();  // 0x47 (GYRO_ZOUT_H) & 0x48 (GYRO_ZOUT_L)
*/

  GyX=Wire.read()<<8|Wire.read();  // 0x43 (GYRO_XOUT_H) & 0x44 (GYRO_XOUT_L)
  GyY=Wire.read()<<8|Wire.read();  // 0x45 (GYRO_YOUT_H) & 0x46 (GYRO_YOUT_L)
  GyZ=Wire.read()<<8|Wire.read();  // 0x47 (GYRO_ZOUT_H) & 0x48 (GYRO_ZOUT_L)

  
// Apply Low Pass Filter to signal to smooth output from MPU 6050
    smoothedX = (alpha * smoothedX) + ( (1 - alpha) * GyX);
    smoothedY = (alpha * smoothedY) + ( (1 - alpha) * GyY);
    smoothedZ = (alpha * smoothedZ) + ( (1 - alpha) * GyZ);


// Calculate final Gyro Colors for XYZ to RGB

if (abs(smoothedX)*josX < 256) {
    Xcol = abs(smoothedX)*josX;
} else {
  Xcol = 0;
}

if (abs(smoothedY)*josY < 256) {
    Ycol = abs(smoothedY)*josY;
} else {
  Ycol = 0;
}

if (abs(smoothedZ)*josZ < 256) {
    Zcol = abs(smoothedZ)*josZ;
} else {
  Zcol = 0;
}

/*  
  Serial.print("AcX = "); Serial.print(AcX);
  Serial.print(" | AcY = "); Serial.print(AcY);
  Serial.print(" | AcZ = "); Serial.print(AcZ);
  Serial.print(" | Tmp = "); Serial.print(Tmp/340.00+36.53);  //equation for temperature in degrees C from datasheet
  Serial.print(" | GyX = "); Serial.print(GyX);
  Serial.print(" | GyY = "); Serial.print(GyY);
  Serial.print(" | GyZ = "); Serial.println(GyZ);

*/

  Serial.print(" . Xb  ");
 Serial.print(xb);
   Serial.print(" . sX  ");
    Serial.print(abs(smoothedX));
       Serial.print(" . gX.  ");
        Serial.print(dt);
   
  Serial.print(" . Yb.  ");
  Serial.print(yb);
    Serial.print(" . sY   ");
     Serial.print(abs(smoothedY));
            Serial.print(" . gY   ");
              Serial.print(dt);
    
  Serial.print(" . Zb . ");
   Serial.print(zb);
     Serial.print(" . sZ   ");
      Serial.print(abs(smoothedZ));
             Serial.print(" . gZ   ");
        Serial.println(dt);


//  Serial.print(" | GyX = "); Serial.print(GyX); Serial.print("    ");
//  Serial.print(" | smoothedX = "); Serial.print(smoothedX);

//    Serial.print(" | GyY = "); Serial.print(GyY); Serial.print("    ");
//  Serial.print(" | smoothedY = "); Serial.print(smoothedY);

//    Serial.print(" | GyZ = "); Serial.print(GyZ); Serial.print("    ");
//  Serial.print(" | smoothedZ = "); Serial.println(smoothedZ);




// smoothedX value between -12000 and +15000 



// Display color on all leds

//********************************************************************************
// Display Random Dot Snakes that move randomly around the ball

  if (menu == 1 ) {
    DotOnTop(); // Dot remains on top
  }
  

  if (menu == 2 ) {
    Spirallights(); // LED Snakes down sphere
  }


  if (menu == 3 ) {
    GyroSpirallights(); // Gyro Spiral Colour
  }

    if (menu == 4) {

  DotSnakes(); // Four independent DOT Snakes chase around Sphere

  }
  

    if (menu == 5) {

    AxisGyroLights();  // Menu Option 5 - LED chaser around axis of Sphere using Gyro Colour

  /* LED Track as follows 
   *  57 to 72 X Axis
   *  0, 1, 10, 26, 42, 58, 74 , 90, 106, 121, 129, 125, 114, 98, 82,66, 50, 34, 18, 5
   */
    }

}

//********************************************
// Dotsnakes menu option 4
// *******************************************

void DotSnakes() {

      
      // Dot 0
     leds[dot[0][0]] = CRGB::Blue; 
     leds[dot[0][2]] = CRGB::Blue; 
     leds[dot[0][3]] = CRGB::Blue;     
     leds[dot[0][4]] = CRGB::Blue;    
    FastLED.show(); 
     // Randomly change direction of Dot
  
     direct = random(8); // Randomly determine new direction

     // Check not going backwards    
     while ((abs(dot[0][1] - direct)) == 4){
        direct = random(8); // Randomly determine new direction
     }
     
     dot[0][1] = direct; // Store value in array

     
     leds[dot[0][0]] = CRGB::Black;  // Turn off current LED position
     leds[dot[0][2]] = CRGB::Black;  // Turn off current LED position
     leds[dot[0][3]] = CRGB::Black;  // Turn off current LED position    
     leds[dot[0][4]] = CRGB::Black;  // Turn off current LED position        
     FastLED.show(); 

    // Update position of data based on new direction before displaying
     dot[0][4] = dot[0][3]; // Store prevprev into prevprevprev location
     dot[0][3] = dot[0][2]; // Store prev into prevprev location
     dot[0][2] = dot[0][0]; // Store current into prev location   
      
     dot[0][0]= pgm_read_byte(&(pixel[dot[0][0]][dot[0][1]])); // Use pgm_read_byte function to read data back from array in Progam Memory

     leds[dot[0][0]] = CRGB::Blue; 
     leds[dot[0][2]] = CRGB::Blue; 
     leds[dot[0][3]] = CRGB::Blue;     
     leds[dot[0][4]] = CRGB::Blue;   
     FastLED.show(); 

//  delay(d1);
  
    // Dot 1
     leds[dot[1][0]] = CRGB::Red;
     leds[dot[1][2]] = CRGB::Red;
     leds[dot[1][3]] = CRGB::Red;     
     leds[dot[1][4]] = CRGB::Red;   
    FastLED.show(); 

     // Randomly change direction of Dot
     direct = random(8); // Randomly determine new direction
     // Check not going backwards    
     while ((abs(dot[1][1] - direct)) == 4){
        direct = random(8); // Randomly determine new direction
     }
    
     dot[1][1] = direct; // Modify lead dot position and store value in array
     
     leds[dot[1][0]] = CRGB::Black;  // Turn off current LED position
     leds[dot[1][2]] = CRGB::Black;  // Turn off current LED position
     leds[dot[1][3]] = CRGB::Black;  // Turn off current LED position    
     leds[dot[1][4]] = CRGB::Black;  // Turn off current LED position        
     FastLED.show(); 

    // Update position of data based on new direction before displaying
     dot[1][4] = dot[1][3]; // Store prevprev into prevprevprev location
     dot[1][3] = dot[1][2]; // Store prev into prevprev location
     dot[1][2] = dot[1][0]; // Store current into prev location   

     dot[1][0]= pgm_read_byte(&(pixel[dot[1][0]][dot[1][1]]));  // Use pgm_read_byte function to read data back from array in Progam Memory

     leds[dot[1][0]] = CRGB::Red;
     leds[dot[1][2]] = CRGB::Red;
     leds[dot[1][3]] = CRGB::Red; 
     leds[dot[1][4]] = CRGB::Red;       
     FastLED.show(); 

//  delay(d1);  
    
    // Dot 2 *****************************************  
     leds[dot[2][0]] = CRGB::Green;
     leds[dot[2][2]] = CRGB::Green;
     leds[dot[2][3]] = CRGB::Green;     
     leds[dot[2][4]] = CRGB::Green;         
    FastLED.show(); 

     // Randomly change direction of Dot
     direct = random(8); // Randomly determine new direction
     // Check not going backwards    
     while ((abs(dot[2][1] - direct)) == 4){
        direct = random(8); // Randomly determine new direction
     }
     
     dot[2][1] = direct; // Store value in array

     leds[dot[2][0]] = CRGB::Black;  // Turn off current LED position
     leds[dot[2][2]] = CRGB::Black;  // Turn off current LED position
     leds[dot[2][3]] = CRGB::Black;  // Turn off current LED position    
     leds[dot[2][4]] = CRGB::Black;  // Turn off current LED position        
     FastLED.show(); 

      // Update position of data based on new direction before displaying
       dot[2][4] = dot[2][3]; // Store prevprev into prevprevprev location
       dot[2][3] = dot[2][2]; // Store prev into prevprev location
       dot[2][2] = dot[2][0]; // Store current into prev location       
     
     dot[2][0]= pgm_read_byte(&(pixel[dot[2][0]][dot[2][1]]));   // Use pgm_read_byte function to read data back from array in Progam Memory
     leds[dot[2][0]] = CRGB::Green;
     leds[dot[2][2]] = CRGB::Green;
     leds[dot[2][3]] = CRGB::Green;     
     leds[dot[2][4]] = CRGB::Green;     
     
     FastLED.show(); 

//  delay(d1);
  
    // Dot 3 *****************************************  
     leds[dot[3][0]] = CRGB::Purple;
     leds[dot[3][2]] = CRGB::Purple;
     leds[dot[3][3]] = CRGB::Purple;
     leds[dot[3][4]] = CRGB::Purple;
     FastLED.show(); 

     // Randomly change direction of Dot  
     direct = random(8); // Randomly determine new direction
     // Check not going backwards    
     while ((abs(dot[3][1] - direct)) == 4){
        direct = random(8); // Randomly determine new direction
     }     
     dot[3][1] = direct; // Store value in array
     
     leds[dot[3][0]] = CRGB::Black;  // Turn off current LED position
     leds[dot[3][2]] = CRGB::Black;  // Turn off current LED position
     leds[dot[3][3]] = CRGB::Black;  // Turn off current LED position    
     leds[dot[3][4]] = CRGB::Black;  // Turn off current LED position        
     FastLED.show(); 

      // Update position of data based on new direction before displaying
       dot[3][4] = dot[3][3]; // Store prevprev into prevprevprev location
       dot[3][3] = dot[3][2]; // Store prev into prevprev location
       dot[3][2] = dot[3][0]; // Store current into prev location     
       
     dot[3][0]= pgm_read_byte(&(pixel[dot[3][0]][dot[3][1]]));   // Use pgm_read_byte function to read data back from array in Progam Memory

     leds[dot[3][0]] = CRGB::Purple;
     leds[dot[3][2]] = CRGB::Purple;
     leds[dot[3][3]] = CRGB::Purple;
     leds[dot[3][4]] = CRGB::Purple;        
     FastLED.show(); 

  delay(d1);
  delay(d1);
  delay(d1);    
}


//********************************************
// Spirallights menu option 2
// *******************************************
void Spirallights() { // LED Snakes down sphere


  if ( g < 140 && menu == 2 ) {

    if ( g < 130 ) {
        leds[g] = CRGB::Blue;
    }
    delay(d1);  
    if (g>9) {
        leds[g-10] = CRGB::Black;
    } 
    FastLED.show();
    buttoncheck();
    g++; 
  } else {
  g = 0;
  }

}

void buttoncheck() { // Debounce Button Check

        // Increment Menu
      if((digitalRead(4) == LOW ) && (digitalRead(5) == HIGH)){ // Check that one button pushed only
        delay(200); // Debounce by waiting then checking again
        if((digitalRead(4) == LOW) && (digitalRead(5) == HIGH)){
            // Now confirmed legitimate request increment menu variable
            if (menu < 10 ) {
                menu++;
                clearsphere(); // Clear the entire LED Array to Black
                g = 0;
                i = 0;
             }
        }
      delay(200);
      }
      
      // Decrement Menu
      if((digitalRead(5) == LOW) && (digitalRead(4) == HIGH)){ // Check that one button pushed only
        delay(200); // Debounce by waiting then checking again
        if((digitalRead(5) == LOW) && (digitalRead(4) == HIGH)){
          // Now confirmed legitimate request increment menu variable
          if (menu > 1 ) {
            menu--;
            clearsphere(); // Clear the entire LED Array to Black  
                g = 0;
                i = 0;      
          }
        }
      delay(200);
      }      
//  Serial.println(menu);     // Temporarily print menu output for testing
}

void clearsphere() { // Clear the entire LED array to black

  for (int h = 0; h < 130; h++) {
     leds[h] = CRGB::Black;
    FastLED.show();
  }
}

void AxisGyroLights() { // Menu Option 5 - LED chaser around axis of Sphere using Gyro Colour

  /* LED Track as follows 
   *  57 to 72 X Axis
   *  0, 1, 10, 26, 42, 58, 74 , 90, 106, 121, 129, 125, 114, 98, 82,66, 50, 34, 18, 5
   */

    // Color the LEDs based on Gyro position
    leds[gX].setRGB( (Xcol), (Ycol), (Zcol));    
    leds[dY[gY]].setRGB( (Xcol), (Ycol), (Zcol));   

//    leds[gX].setRGB( (0.0182*abs(smoothedX)), (0.0182*abs(smoothedY)), (0.0182*abs(smoothedZ)));     
//    leds[dY[gY]].setRGB( (0.0182*abs(smoothedX)), (0.0182*abs(smoothedY)), (0.0182*abs(smoothedZ)));      
    
    
    FastLED.show();  

    delay(d5);  // Delay before blanking LEDs
  
    leds[gX] = CRGB::Black;
    leds[dY[gY]] = CRGB::Black;
    FastLED.show();       
           
    gX++; // Increment horizontal axis LED then check has not reached limit
    if (gX > 72) {
      gX =57;
    }
    gY++; // Increment vertical axis LED then check has not reached limit
    if (gY > 19) {
      gY = 0;
    }
    
     
    buttoncheck();
}


//********************************************
// GyroSpirallights menu option 4
// *******************************************
void GyroSpirallights() { // GyroLED Snakes down sphere


  if ( i < 140 && menu == 3 ) {

    if ( i < 130 ) {

//        leds[i].setRGB( (0.0182*abs(smoothedX)), (0.0182*abs(smoothedY)), (0.0182*abs(smoothedZ)));          
        leds[i].setRGB( (Xcol), (Ycol), (Zcol)); 
    }
    delay(d1);  
    if (i>9) {
        leds[i-10] = CRGB::Black;
    } 
    FastLED.show();
    buttoncheck();
    i++; 
  } else {
  i = 0;
  }

}



//********************************************
// DotOnTop menu option 1
// *******************************************
void DotOnTop() { // LED stays in top of sphere

  // Callibrate with 5 second count down

if (cal == false) { // Delay count down timer to let MPU 6050 stabilize
      five();
      delay(d1);        
      four();
      delay(d1);  
      three();
      delay(d1);       
      two();
      delay(d1);  
      one();
      delay(d1);  
      zero();
      delay(d1); 
  cal = true;
// get a baseline of X,Y,Z coordinates from smoothing algorithm

  xb = smoothedX;
  yb = smoothedY;
  zb = smoothedZ;

}



// Display dot on top of ball

//    leds[dt] = CRGB::Black; // turn off existing dot
//    FastLED.show(); 

   leds[r] = CRGB::Black;
   FastLED.show();
    r++;    
  if ( r < 41 ) {
        leds[r] = CRGB::Red;
    FastLED.show();
    delay(d1);  
    buttoncheck();

  } else {
  r = 24;
  }





/*  Change direction of Dot based on Gyro readings for X, Y & Z and express as 0-7 based on     
     0 = Up 1 = Up Right   2 = Right  3 =  Down Right   
     4 = Down 5 = Down Left 6 = Left  7 = Up Left
   
*/

/*
  if (smoothedX > (xgap + xb)) { // Capture incremental move to up
    xb = smoothedX; // Capture new current value as baseline
    dt = pgm_read_byte(&(pixel[dt][0]));  // Use pgm_read_byte function to read data back from array in Progam Memory
  } else
  if (smoothedX < (xgap - xb)) { // Capture incremental move to down
    xb = smoothedX; // Capture new current value as baseline
    dt = pgm_read_byte(&(pixel[dt][4]));  // Use pgm_read_byte function to read data back from array in Progam Memory
  }

     leds[dt] = CRGB::Red;     
     FastLED.show(); 
     
  if (smoothedY > (ygap - yb)) { // Capture incremental move to left
    yb = smoothedY; // Capture new current value as baseline

    leds[dt] = CRGB::Black; // turn off existing dot
    dt = pgm_read_byte(&(pixel[dt][6]));  // Use pgm_read_byte function to read data back from array in Progam Memory
  } else
  if (smoothedY < (ygap + yb)) { // Capture incremental move to right
    yb = smoothedY; // Capture new current value as baseline

    leds[dt] = CRGB::Black; // turn off existing dot
    dt = pgm_read_byte(&(pixel[dt][2]));  // Use pgm_read_byte function to read data back from array in Progam Memory
  }
     leds[dt] = CRGB::Red;     
     FastLED.show(); 

     
  if (smoothedZ > (ygap - zb)) { // Capture incremental move to left
    zb = smoothedZ; // Capture new current value as baseline

    leds[dt] = CRGB::Black; // turn off existing dot
    dt = pgm_read_byte(&(pixel[dt][1]));  // Use pgm_read_byte function to read data back from array in Progam Memory
  } else
  if (smoothedZ < (ygap + zb)) { // Capture incremental move to right
    zb = smoothedZ; // Capture new current value as baseline

    leds[dt] = CRGB::Black; // turn off existing dot
    dt = pgm_read_byte(&(pixel[dt][7]));  // Use pgm_read_byte function to read data back from array in Progam Memory
  }



     leds[dt] = CRGB::Red;     
     FastLED.show(); 

  */   



 
  buttoncheck();

}

void eight() {

    leds[33] = CRGB::Blue;
    leds[34] = CRGB::Blue;
    leds[35] = CRGB::Blue;
    leds[49] = CRGB::Blue;
    leds[51] = CRGB::Blue;
    leds[65] = CRGB::Blue;
    leds[66] = CRGB::Blue;
    leds[67] = CRGB::Blue;
    leds[83] = CRGB::Blue;
    leds[81] = CRGB::Blue;
    leds[99] = CRGB::Blue;
    leds[98] = CRGB::Blue;
    leds[97] = CRGB::Blue;
        
    FastLED.show();

    delay(d2); 



    leds[33] = CRGB::Black;
    leds[34] = CRGB::Black;
    leds[35] = CRGB::Black;
    leds[49] = CRGB::Black;
    leds[51] = CRGB::Black;
    leds[65] = CRGB::Black;
    leds[66] = CRGB::Black;
    leds[67] = CRGB::Black;
    leds[83] = CRGB::Black;
    leds[81] = CRGB::Black;
    leds[99] = CRGB::Black;
    leds[98] = CRGB::Black;
    leds[97] = CRGB::Black;
    
    FastLED.show();
}


void five() {

    leds[33] = CRGB::Blue;
    leds[34] = CRGB::Blue;
    leds[35] = CRGB::Blue;
//    leds[49] = CRGB::Blue;
    leds[51] = CRGB::Blue;
    leds[65] = CRGB::Blue;
    leds[66] = CRGB::Blue;
    leds[67] = CRGB::Blue;
//    leds[83] = CRGB::Blue;
    leds[81] = CRGB::Blue;
    leds[99] = CRGB::Blue;
    leds[98] = CRGB::Blue;
    leds[97] = CRGB::Blue;
        
    FastLED.show();

    delay(d2); 



    leds[33] = CRGB::Black;
    leds[34] = CRGB::Black;
    leds[35] = CRGB::Black;
    leds[49] = CRGB::Black;
    leds[51] = CRGB::Black;
    leds[65] = CRGB::Black;
    leds[66] = CRGB::Black;
    leds[67] = CRGB::Black;
    leds[83] = CRGB::Black;
    leds[81] = CRGB::Black;
    leds[99] = CRGB::Black;
    leds[98] = CRGB::Black;
    leds[97] = CRGB::Black;
    
    FastLED.show();
}

void four() {

    leds[33] = CRGB::Blue;
//    leds[34] = CRGB::Blue;
    leds[35] = CRGB::Blue;
    leds[49] = CRGB::Blue;
    leds[51] = CRGB::Blue;
    leds[65] = CRGB::Blue;
    leds[66] = CRGB::Blue;
    leds[67] = CRGB::Blue;
//    leds[83] = CRGB::Blue;
    leds[81] = CRGB::Blue;
//    leds[99] = CRGB::Blue;
//    leds[98] = CRGB::Blue;
    leds[97] = CRGB::Blue;
        
    FastLED.show();

    delay(d2); 



    leds[33] = CRGB::Black;
    leds[34] = CRGB::Black;
    leds[35] = CRGB::Black;
    leds[49] = CRGB::Black;
    leds[51] = CRGB::Black;
    leds[65] = CRGB::Black;
    leds[66] = CRGB::Black;
    leds[67] = CRGB::Black;
    leds[83] = CRGB::Black;
    leds[81] = CRGB::Black;
    leds[99] = CRGB::Black;
    leds[98] = CRGB::Black;
    leds[97] = CRGB::Black;
    
    FastLED.show();
}

void three() {

    leds[33] = CRGB::Blue;
    leds[34] = CRGB::Blue;
    leds[35] = CRGB::Blue;
    leds[49] = CRGB::Blue;
//    leds[51] = CRGB::Blue;
    leds[65] = CRGB::Blue;
    leds[66] = CRGB::Blue;
    leds[67] = CRGB::Blue;
//    leds[83] = CRGB::Blue;
    leds[81] = CRGB::Blue;
    leds[99] = CRGB::Blue;
    leds[98] = CRGB::Blue;
    leds[97] = CRGB::Blue;
        
    FastLED.show();

    delay(d2); 



    leds[33] = CRGB::Black;
    leds[34] = CRGB::Black;
    leds[35] = CRGB::Black;
    leds[49] = CRGB::Black;
    leds[51] = CRGB::Black;
    leds[65] = CRGB::Black;
    leds[66] = CRGB::Black;
    leds[67] = CRGB::Black;
    leds[83] = CRGB::Black;
    leds[81] = CRGB::Black;
    leds[99] = CRGB::Black;
    leds[98] = CRGB::Black;
    leds[97] = CRGB::Black;
    
    FastLED.show();
}

void two() {

    leds[33] = CRGB::Blue;
    leds[34] = CRGB::Blue;
    leds[35] = CRGB::Blue;
    leds[49] = CRGB::Blue;
//    leds[51] = CRGB::Blue;
    leds[65] = CRGB::Blue;
    leds[66] = CRGB::Blue;
    leds[67] = CRGB::Blue;
    leds[83] = CRGB::Blue;
//    leds[81] = CRGB::Blue;
    leds[99] = CRGB::Blue;
    leds[98] = CRGB::Blue;
    leds[97] = CRGB::Blue;
        
    FastLED.show();

    delay(d2); 


    leds[33] = CRGB::Black;
    leds[34] = CRGB::Black;
    leds[35] = CRGB::Black;
    leds[49] = CRGB::Black;
    leds[51] = CRGB::Black;
    leds[65] = CRGB::Black;
    leds[66] = CRGB::Black;
    leds[67] = CRGB::Black;
    leds[83] = CRGB::Black;
    leds[81] = CRGB::Black;
    leds[99] = CRGB::Black;
    leds[98] = CRGB::Black;
    leds[97] = CRGB::Black;

        FastLED.show();

}

void one() {

    leds[33] = CRGB::Blue;
//    leds[34] = CRGB::Blue;
//    leds[35] = CRGB::Blue;
    leds[49] = CRGB::Blue;
//    leds[51] = CRGB::Blue;
    leds[65] = CRGB::Blue;
//    leds[66] = CRGB::Blue;
//    leds[67] = CRGB::Blue;
//    leds[83] = CRGB::Blue;
    leds[81] = CRGB::Blue;
//    leds[99] = CRGB::Blue;
//    leds[98] = CRGB::Blue;
    leds[97] = CRGB::Blue;
        
    FastLED.show();

    delay(d2); 



    leds[33] = CRGB::Black;
    leds[34] = CRGB::Black;
    leds[35] = CRGB::Black;
    leds[49] = CRGB::Black;
    leds[51] = CRGB::Black;
    leds[65] = CRGB::Black;
    leds[66] = CRGB::Black;
    leds[67] = CRGB::Black;
    leds[83] = CRGB::Black;
    leds[81] = CRGB::Black;
    leds[99] = CRGB::Black;
    leds[98] = CRGB::Black;
    leds[97] = CRGB::Black;
    
    FastLED.show();
}

void zero() {

    leds[33] = CRGB::Blue;
    leds[34] = CRGB::Blue;
    leds[35] = CRGB::Blue;
    leds[49] = CRGB::Blue;
    leds[51] = CRGB::Blue;
    leds[65] = CRGB::Blue;
//    leds[66] = CRGB::Blue;
    leds[67] = CRGB::Blue;
    leds[83] = CRGB::Blue;
    leds[81] = CRGB::Blue;
    leds[99] = CRGB::Blue;
    leds[98] = CRGB::Blue;
    leds[97] = CRGB::Blue;
        
    FastLED.show();

    delay(d2); 



    leds[33] = CRGB::Black;
    leds[34] = CRGB::Black;
    leds[35] = CRGB::Black;
    leds[49] = CRGB::Black;
    leds[51] = CRGB::Black;
    leds[65] = CRGB::Black;
    leds[66] = CRGB::Black;
    leds[67] = CRGB::Black;
    leds[83] = CRGB::Black;
    leds[81] = CRGB::Black;
    leds[99] = CRGB::Black;
    leds[98] = CRGB::Black;
    leds[97] = CRGB::Black;

    FastLED.show();    

}

